# Spring 5.0 Microservices - Second Edition
This is the code repository for [Spring 5.0 Microservices - Second Edition](https://www.packtpub.com/application-development/spring-50-microservices-second-edition?utm_source=github&utm_medium=repository&utm_campaign=9781787127685), published by [Packt](https://www.packtpub.com/?utm_source=github). It contains all the supporting project files necessary to work through the book from start to finish.
## About the Book
The Spring Framework is an application framework and inversion of the control container for the Java platform. The framework's core features can be used by any Java application, but there are extensions to build web applications on top of the Java EE platform.


## Instructions and Navigation
All of the code is organized into folders. Each folder starts with a number followed by the application name. For example, Chapter03.

Chapters 1, 2, 4, 5, 11 does not have any code files.

The code will look like the following:
```
    @SpringBootApplication
    public class Application {
      public static void main(String[] args) {
        SpringApplication.run(Application.class, args);
      }
    }
```
You will need the following tools for running the codes in the book:
* JDK 1.8
* Spring Tool Suite 3.8.2 (STS)
* Maven 3.3.1
* Spring Framework 5.0.0.RC1
* Spring Boot 2.0.0. SNAPSHOT
* spring-boot-cli-2.0.0.SNAPSHOT-bin.zip
* Rabbit MQ 3.5.6
* FakeSMTP 2.0
* Spring Cloud Dalston RELEASE
* elasticsearch-1.5.2
* kibana-4.0.2-darwin-x64
* logstash-2.1.2
* Docker version (17.03.1-ce)
* Docker Hub
* Mesos version 1.2.0
* Docker version 17.03.1-ce
* Marathon version 3.4.9


## Related Products
* [Learning Spring 5.0](https://www.packtpub.com/application-development/learning-spring-50?utm_source=github&utm_medium=repository&utm_campaign=9781787120341)

* [Essentials of Spring 5.0 for Developers [Video]](https://www.packtpub.com/application-development/essentials-spring-50-developers-video?utm_source=github&utm_medium=repository&utm_campaign=9781787283893)

* [Spring 5.0 Recipes](https://www.packtpub.com/application-development/spring-50-recipes?utm_source=github&utm_medium=repository&utm_campaign=9781787128316)
